----------------------------------------------------------------------------------
-- Company: Digilent Inc. 2011
-- Engineer: Michelle Yu
-- 
-- Create Date:    12:20:59 09/01/2011 
-- Module Name:    clkdiv - Behavioral 
-- Project Name:  PmodSF
-- Target Devices: Nexys3 
-- Tool versions: Xilinx ISE design suite 13.2
-- Description: 
--  This files defines a clock divider that divides the main clock to 100K Hz
--
-- Revision: 
-- Revision 0.01 - File Created
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity clkdiv is
    Port ( clk : in  STD_LOGIC;
           clk100K : inout  STD_LOGIC);
end clkdiv;

architecture Behavioral of clkdiv is
signal div : std_logic_vector ( 9 downto 0);
begin

process(clk)
   begin
      if rising_edge(Clk) then
			-- 0b1111101000 = 1000
			-- input clk is 100MHz, 100MHz /1000= 100K Hz 
         if div = "1111101000" then 
				clk100K <= not clk100K;
				div <= "0000000000";
			else 
				div <= div +1;
		   end if;
      end if;
   end process;


end Behavioral;

